/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * calc_threshold.h - 14/01/2003
 *
 * Threshold on pixel values
*/


#ifndef NPIC__CALC_TRESHOLD_H
#define NPIC__CALC_TRESHOLD_H


/* PUBLIC */

void NpicThresholdLT_i (Npic_image *np, int val1, int val2);
void NpicThresholdLT_d (Npic_image *np, double val1, double val2);
void NpicThresholdLT_q (Npic_image *np, int a1, int b1, int c1, int d1,
    int a2, int b2, int c2, int d2);
    
void NpicThresholdLE_i (Npic_image *np, int val1, int val2);
void NpicThresholdLE_d (Npic_image *np, double val1, double val2);
void NpicThresholdLE_q (Npic_image *np, int a1, int b1, int c1, int d1,
    int a2, int b2, int c2, int d2);
    
void NpicThresholdGT_i (Npic_image *np, int val1, int val2);
void NpicThresholdGT_d (Npic_image *np, double val1, double val2);
void NpicThresholdGT_q (Npic_image *np, int a1, int b1, int c1, int d1,
    int a2, int b2, int c2, int d2);
    
void NpicThresholdGE_i (Npic_image *np, int val1, int val2);
void NpicThresholdGE_d (Npic_image *np, double val1, double val2);
void NpicThresholdGE_q (Npic_image *np, int a1, int b1, int c1, int d1,
    int a2, int b2, int c2, int d2);


/* PRIVATE */


#endif /* NPIC__CALC_TRESHOLD_H */
