/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * errors.h - 09/01/2003
 *
 * Error messages
*/


#ifndef NPIC__ERRORS_H
#define NPIC__ERRORS_H


#define NPIC_SUCCESS            0
#define NPIC_ERROR             -1

#define NPIC_ERR_NULL_PTR     -10
#define NPIC_ERR_NOT_INIT     -11
#define NPIC_ERR_UNEX_NPIC    -12
#define NPIC_ERR_UNEX_TYPE    -13
#define NPIC_ERR_NOT_OK       -14
#define NPIC_ERR_EMPTY_STR    -15
#define NPIC_ERR_NOT_FOUND    -16

#define NPIC_ERR_BAD_SIZE     -20
#define NPIC_ERR_INCOMPAT     -21
#define NPIC_ERR_BAD_CONV     -22
#define NPIC_ERR_BAD_SRC      -23
#define NPIC_ERR_BAD_EXT      -24
#define NPIC_ERR_UNAV_FORMAT  -25
#define NPIC_ERR_UNAV_DIST    -26

#define NPIC_ERR_MALLOC       -30
#define NPIC_ERR_REALLOC      -31
#define NPIC_ERR_STRDUP       -32

#define NPIC_ERR_MAGIC        -40
#define NPIC_ERR_VERSION      -41
#define NPIC_ERR_HEADER       -42
#define NPIC_ERR_ENDIAN       -43
#define NPIC_ERR_FLOAT        -44

#define NPIC_ERR_OPEN         -50
#define NPIC_ERR_READ         -51
#define NPIC_ERR_WRITE        -52
#define NPIC_ERR_BAD_FD       -53
#define NPIC_ERR_DUP_FD       -54
#define NPIC_ERR_GETPOS       -55
#define NPIC_ERR_SETPOS       -56
#define NPIC_ERR_FDOPEN       -57

#define NPIC_ERR_PIPE         -60
#define NPIC_ERR_FORK         -61
#define NPIC_ERR_EXEC         -62
#define NPIC_ERR_CHILD        -63

#define NPIC_ERR_SLICE_RG     -70
#define NPIC_ERR_BAND_NB      -71


/* PUBLIC */
const char *NpicStrErr (int err);
int NpicError (const char *funcname, int err, const char *format, ...);


#endif /* NPIC__ERRORS_H */

