/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * files_nmask.h - 29/09/2008
 *
 * Read or write masks for distance transforms or medial axis
*/


#ifndef NPIC__FILES_NMASK_H
#define NPIC__FILES_NMASK_H


/* PUBLIC */

int NpicWriteMask (Npic_mask *m, const char *filename);
Npic_mask *NpicReadMask (const char *filename);
int NpicInfoMask (const char *filename);

Npic_mask *NpicReadDistanceMask (const char *filename);
Npic_mask *NpicReadMedialAxisMask (const char *filename);

int NpicWriteNMASK (Npic_mask *m, const char *filename, Npic_file_compress comp);
Npic_mask *NpicReadNMASK (const char *filename, Npic_file_compress comp);
int NpicInfoNMASK (const char *filename, Npic_file_compress comp);


/* PRIVATE */

typedef struct {
    int   version,
          type,
          dim;
    Npic_props props;   /* Text properties */
} Npic_nmask_info;

int NpicNMASKWriteFile (Npic_mask *m, FILE *f1, const char *filename, 
        const char *funcname);
Npic_mask *NpicNMASKReadFile (FILE *f1, const char *filename, 
        const char *funcname);
int NPicNMASKReadInfo (FILE *f1, Npic_nmask_info *info);
int NpicNMASKReadDatas (Npic_mask *m, FILE *f1);
int NpicNMASKPrintInfo (const char *filename, Npic_nmask_info *info);


#endif /* NPIC__FILES_NMASK_H */
