/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * image_border.h - 20/01/2003
 *
 * Manage border
*/


#ifndef NPIC__IMAGE_BORDER_H
#define NPIC__IMAGE_BORDER_H


/* PUBLIC */

void NpicSetBorderWidth (Npic_image *np, int tbor, int zbor, int ybor, 
        int xbor);
void NpicSetBorderWidth6 (Npic_image *np, int rbor, int sbor, int tbor, 
        int zbor, int ybor, int xbor);
void NpicSetBorderWidthSame (Npic_image *np, int bord);
void NpicSetBorderWidthMin (Npic_image *np, int bord);

void NpicFillWholeZero (Npic_image *np);

void NpicFillWhole_i (Npic_image *np, int val1);
void NpicFillWhole_d (Npic_image *np, double val1);
void NpicFillWhole_q (Npic_image *np, int a, int b, int c, int d);

void NpicFillBorder_i (Npic_image *np, int val1);
void NpicFillBorder_d (Npic_image *np, double val1);
void NpicFillBorder_q (Npic_image *np, int a, int b, int c, int d);

void NpicMirrorBorder (Npic_image *np);


/* PRIVATE */


#endif /* NPIC__IMAGE_BORDER_H */
