/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * image_check.h - 25/11/2008
 *
 * Check images
*/


#ifndef NPIC__IMAGE_CHECK_H
#define NPIC__IMAGE_CHECK_H


/* Used by NpicCompareTypes() */
enum {
        NPIC_TYPE = 1L<<0 ,
        NPIC_DIM  = 1L<<1 ,
        NPIC_SIZE = 1L<<2 ,
        NPIC_BORD = 1L<<3 
};


/* PUBLIC */

int NpicImageIsOK (Npic_image *np, const char *funcname);
int NpicImageIsOK_DS1 (Npic_image *dest, Npic_image *src1, 
                              char const *funcname);
int NpicImageIsOK_DS2 (Npic_image *dest, Npic_image *src1, 
                              Npic_image *src2, const char *funcname);
int NpicImageIsOK_DS3 (Npic_image *dest, Npic_image *src1, 
                              Npic_image *src2, Npic_image *src3, 
                              const char *funcname);
int NpicImageIsSquare (Npic_image *np1, const char *funcname);
int NpicSameImage (Npic_image *np1, Npic_image *np2, int what);


/* PRIVATE */


#endif /* NPIC__IMAGE_CREAT_H */
