/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * image_prop.h - 25/11/2008
 *
 * Text properties for images
*/


#ifndef NPIC__IMAGE_PROP_H
#define NPIC__IMAGE_PROP_H


/* PUBLIC */

int NpicImageCopyProps (Npic_image *dest, Npic_image *src);
void NpicImageFreeProps (Npic_image *m);
int NpicImageAddProp (Npic_image *np, const char *key, const char *val);
int NpicImageSupprProp (Npic_image *np, const char *key);
const char *NpicImageGetProp (Npic_image *np, const char *key);
const char *NpicImageGetPropD (Npic_image *np, const char *key, const char *default_val);
int NpicImageHasProp (Npic_image *np, const char *key);
void NpicImagePrintProps (Npic_image *np);


/* PRIVATE */


#endif /* NPIC__IMAGE_PROP_H */
