/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/* DO NOT EDIT !!!  Generated by npic-templa from "mask_prop.ct" */

/*
 * mask_prop.c - 25/11/2008
 *
 * Text properties for masks
*/


#include <npic.h>


/*--------------------- P U B L I C - I N T E R F A C E ----------------------*/

/*
 * Interface for properties ; see props.c
 * Do nothing if mask is not ok.
*/

int NpicMaskCopyProps (Npic_mask *dest, Npic_mask *src)
{
    if (NpicMaskIsOK (src , __func__) != NPIC_SUCCESS ||
        NpicMaskIsOK (dest, __func__) != NPIC_SUCCESS)
        return NPIC_ERR_NOT_OK;
    
    return NpicCopyProps (&dest->gen.props, &src->gen.props);
}

void NpicMaskFreeProps (Npic_mask *m)
{
    if (NpicMaskIsOK (m, __func__) != NPIC_SUCCESS)
        return ;

    NpicFreeProps (&m->gen.props);
}

int NpicMaskAddProp (Npic_mask *m, const char *key, const char *val)
{
    if (NpicMaskIsOK (m, __func__) != NPIC_SUCCESS)
        return NPIC_ERR_NOT_OK;

    return NpicAddProp (&m->gen.props, key, val);
}

int NpicMaskSupprProp (Npic_mask *m, const char *key)
{
    if (NpicMaskIsOK (m, __func__) != NPIC_SUCCESS)
        return NPIC_ERR_NOT_OK;

    return NpicSupprProp (&m->gen.props, key);
}

const char *NpicMaskGetProp (Npic_mask *m, const char *key)
{
    if (NpicMaskIsOK (m, __func__) != NPIC_SUCCESS)
        return "";

    return NpicGetProp (&m->gen.props, key);
}

const char *NpicMaskGetPropD (Npic_mask *m, const char *key, const char *default_val)
{
    if (NpicMaskIsOK (m, __func__) != NPIC_SUCCESS)
        return "";

    return NpicGetPropD (&m->gen.props, key, default_val);
}

int NpicMaskHasProp (Npic_mask *m, const char *key)
{
    if (NpicMaskIsOK (m, __func__) != NPIC_SUCCESS)
        return 0;

    return NpicHasProp (&m->gen.props, key);
}

void NpicMaskPrintProps (Npic_mask *m)
{
    if (NpicMaskIsOK (m, __func__) != NPIC_SUCCESS)
        return;

    NpicPrintProps (&m->gen.props);
}


/*-------------------- P R I V A T E - F U N C T I O N S ---------------------*/


/*----------------------------------------------------------------------------*/

