/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * mask_prop.h - 25/11/2008
 *
 * Text properties for masks
*/


#ifndef NPIC__MASK_PROP_H
#define NPIC__MASK_PROP_H


/* PUBLIC */

int NpicMaskCopyProps (Npic_mask *dest, Npic_mask *src);
void NpicMaskFreeProps (Npic_mask *m);
int NpicMaskAddProp (Npic_mask *m, const char *key, const char *val);
int NpicMaskSupprProp (Npic_mask *m, const char *key);
const char *NpicMaskGetProp (Npic_mask *m, const char *key);
const char *NpicMaskGetPropD (Npic_mask *m, const char *key, const char *default_val);
int NpicMaskHasProp (Npic_mask *m, const char *key);
void NpicMaskPrintProps (Npic_mask *m);


/* PRIVATE */


#endif /* NPIC__MASK_PROP_H */
