/* 
    test-gsym.c
    
    Edouard.Thiel@lif.univ-mrs.fr - 22/01/2004
    
    Compute all the distinct g-symmetries of a point (x[1], .., x[dim])
    which are in the half-mask in scan line order or full mask.

    USAGE: ./test-gsym
*/

#include <npic.h>


int main (int argc, char *argv[])
{
    Npic_gsym gs;
    int i, n = 0;

    printf ("half (1) of full (0) : ");
    if (scanf ("%d", &gs.half) != 1) 
        { fprintf (stderr, "Integer expected\n"); exit (1); }
    
    printf ("dim = ");
    if (scanf ("%d", &gs.dim) != 1) 
        { fprintf (stderr, "Integer expected\n"); exit (1); }
    
    for (i = 1; i <= gs.dim; i++)
    {
        printf ("x[%d] = ", i);
        if (scanf ("%d", &gs.x[i]) != 1) 
            { fprintf (stderr, "Integer expected\n"); exit (1); }
    }
    
    NpicGsymInit (&gs);
    
    while (NpicGsymNext (&gs))
      { NpicGsymPrint (&gs); n++; }
    
    printf ("card = %d\n", n);
    
    exit (0);
}
