/* 
    test-mask.c
    
    Edouard.Thiel@lif.univ-mrs.fr - 08/01/2009
    
    Test the function NpicCompHalfMask()

    USAGE: ./test-mask
*/

/* DO NOT EDIT !!!  Generated by npic-templa from "test-mask.ct" */


#include <npic.h>


int main ()
{
    Npic_mask *mg, *mh, *mi;
    char *name;
    
    /* --------------------------------------- */
    
    mg = NpicCreateMask (NPIC_MASK_2L);
    
    NpicMaskInsert_2l (mg, 0, 1, 3);
    NpicMaskInsert_2l (mg, 1, 1, 4);
    
    mh = NpicCompHalfMask (mg);
    
    name = "tmp1_2l.nmask";
    printf ("Writing %s ...\n", name);
    NpicWriteMask (mh, name);

    printf ("Reading %s ...\n", name);
    mi = NpicReadMask (name);
    
    NpicPrintMask (mi);

    NpicDestroyMask (mg);
    NpicDestroyMask (mh);
    NpicDestroyMask (mi);

    /* --------------------------------------- */
    
    mg = NpicCreateMask (NPIC_MASK_2D);
    
    NpicMaskInsert_2d (mg, 0, 1, 3);
    NpicMaskInsert_2d (mg, 1, 1, 4);
    
    mh = NpicCompHalfMask (mg);
    
    name = "tmp1_2d.nmask";
    printf ("Writing %s ...\n", name);
    NpicWriteMask (mh, name);

    printf ("Reading %s ...\n", name);
    mi = NpicReadMask (name);
    
    NpicPrintMask (mi);

    NpicDestroyMask (mg);
    NpicDestroyMask (mh);
    NpicDestroyMask (mi);

    /* --------------------------------------- */
    
    mg = NpicCreateMask (NPIC_MASK_3L);
    
    NpicMaskInsert_3l (mg, 0, 0, 1, 3);
    NpicMaskInsert_3l (mg, 0, 1, 1, 4);
    NpicMaskInsert_3l (mg, 1, 1, 1, 5);
    
    mh = NpicCompHalfMask (mg);
    
    name = "tmp1_3l.nmask";
    printf ("Writing %s ...\n", name);
    NpicWriteMask (mh, name);

    printf ("Reading %s ...\n", name);
    mi = NpicReadMask (name);
    
    NpicPrintMask (mi);

    NpicDestroyMask (mg);
    NpicDestroyMask (mh);
    NpicDestroyMask (mi);

    /* --------------------------------------- */
    
    mg = NpicCreateMask (NPIC_MASK_3D);
    
    NpicMaskInsert_3d (mg, 0, 0, 1, 3);
    NpicMaskInsert_3d (mg, 0, 1, 1, 4);
    NpicMaskInsert_3d (mg, 1, 1, 1, 5);
    
    mh = NpicCompHalfMask (mg);
    
    name = "tmp1_3d.nmask";
    printf ("Writing %s ...\n", name);
    NpicWriteMask (mh, name);

    printf ("Reading %s ...\n", name);
    mi = NpicReadMask (name);
    
    NpicPrintMask (mi);

    NpicDestroyMask (mg);
    NpicDestroyMask (mh);
    NpicDestroyMask (mi);

    /* --------------------------------------- */
    
    mg = NpicCreateMask (NPIC_MASK_4L);
    
    NpicMaskInsert_4l (mg, 0, 0, 0, 1, 3);
    NpicMaskInsert_4l (mg, 0, 0, 1, 1, 4);
    NpicMaskInsert_4l (mg, 0, 1, 1, 1, 5);
    NpicMaskInsert_4l (mg, 1, 1, 1, 1, 6);
    
    mh = NpicCompHalfMask (mg);
    
    name = "tmp1_4l.nmask";
    printf ("Writing %s ...\n", name);
    NpicWriteMask (mh, name);

    printf ("Reading %s ...\n", name);
    mi = NpicReadMask (name);
    
    NpicPrintMask (mi);

    NpicDestroyMask (mg);
    NpicDestroyMask (mh);
    NpicDestroyMask (mi);

    /* --------------------------------------- */
    
    mg = NpicCreateMask (NPIC_MASK_4D);
    
    NpicMaskInsert_4d (mg, 0, 0, 0, 1, 3);
    NpicMaskInsert_4d (mg, 0, 0, 1, 1, 4);
    NpicMaskInsert_4d (mg, 0, 1, 1, 1, 5);
    NpicMaskInsert_4d (mg, 1, 1, 1, 1, 6);
    
    mh = NpicCompHalfMask (mg);
    
    name = "tmp1_4d.nmask";
    printf ("Writing %s ...\n", name);
    NpicWriteMask (mh, name);

    printf ("Reading %s ...\n", name);
    mi = NpicReadMask (name);
    
    NpicPrintMask (mi);

    NpicDestroyMask (mg);
    NpicDestroyMask (mh);
    NpicDestroyMask (mi);

    /* --------------------------------------- */
    
    mg = NpicCreateMask (NPIC_MASK_5L);
    
    NpicMaskInsert_5l (mg, 0, 0, 0, 0, 1, 3);
    NpicMaskInsert_5l (mg, 0, 0, 0, 1, 1, 4);
    NpicMaskInsert_5l (mg, 0, 0, 1, 1, 1, 5);
    NpicMaskInsert_5l (mg, 0, 1, 1, 1, 1, 6);
    NpicMaskInsert_5l (mg, 1, 1, 1, 1, 1, 7);
    
    mh = NpicCompHalfMask (mg);
    
    name = "tmp1_5l.nmask";
    printf ("Writing %s ...\n", name);
    NpicWriteMask (mh, name);

    printf ("Reading %s ...\n", name);
    mi = NpicReadMask (name);
    
    NpicPrintMask (mi);

    NpicDestroyMask (mg);
    NpicDestroyMask (mh);
    NpicDestroyMask (mi);

    /* --------------------------------------- */
    
    mg = NpicCreateMask (NPIC_MASK_5D);
    
    NpicMaskInsert_5d (mg, 0, 0, 0, 0, 1, 3);
    NpicMaskInsert_5d (mg, 0, 0, 0, 1, 1, 4);
    NpicMaskInsert_5d (mg, 0, 0, 1, 1, 1, 5);
    NpicMaskInsert_5d (mg, 0, 1, 1, 1, 1, 6);
    NpicMaskInsert_5d (mg, 1, 1, 1, 1, 1, 7);
    
    mh = NpicCompHalfMask (mg);
    
    name = "tmp1_5d.nmask";
    printf ("Writing %s ...\n", name);
    NpicWriteMask (mh, name);

    printf ("Reading %s ...\n", name);
    mi = NpicReadMask (name);
    
    NpicPrintMask (mi);

    NpicDestroyMask (mg);
    NpicDestroyMask (mh);
    NpicDestroyMask (mi);

    /* --------------------------------------- */
    
    mg = NpicCreateMask (NPIC_MASK_6L);
    
    NpicMaskInsert_6l (mg, 0, 0, 0, 0, 0, 1, 3);
    NpicMaskInsert_6l (mg, 0, 0, 0, 0, 1, 1, 4);
    NpicMaskInsert_6l (mg, 0, 0, 0, 1, 1, 1, 5);
    NpicMaskInsert_6l (mg, 0, 0, 1, 1, 1, 1, 6);
    NpicMaskInsert_6l (mg, 0, 1, 1, 1, 1, 1, 7);
    NpicMaskInsert_6l (mg, 1, 1, 1, 1, 1, 1, 8);
    
    mh = NpicCompHalfMask (mg);
    
    name = "tmp1_6l.nmask";
    printf ("Writing %s ...\n", name);
    NpicWriteMask (mh, name);

    printf ("Reading %s ...\n", name);
    mi = NpicReadMask (name);
    
    NpicPrintMask (mi);

    NpicDestroyMask (mg);
    NpicDestroyMask (mh);
    NpicDestroyMask (mi);

    /* --------------------------------------- */
    
    mg = NpicCreateMask (NPIC_MASK_6D);
    
    NpicMaskInsert_6d (mg, 0, 0, 0, 0, 0, 1, 3);
    NpicMaskInsert_6d (mg, 0, 0, 0, 0, 1, 1, 4);
    NpicMaskInsert_6d (mg, 0, 0, 0, 1, 1, 1, 5);
    NpicMaskInsert_6d (mg, 0, 0, 1, 1, 1, 1, 6);
    NpicMaskInsert_6d (mg, 0, 1, 1, 1, 1, 1, 7);
    NpicMaskInsert_6d (mg, 1, 1, 1, 1, 1, 1, 8);
    
    mh = NpicCompHalfMask (mg);
    
    name = "tmp1_6d.nmask";
    printf ("Writing %s ...\n", name);
    NpicWriteMask (mh, name);

    printf ("Reading %s ...\n", name);
    mi = NpicReadMask (name);
    
    NpicPrintMask (mi);

    NpicDestroyMask (mg);
    NpicDestroyMask (mh);
    NpicDestroyMask (mi);

    /* --------------------------------------- */
    
    exit (0);
}
