/* 
    test-overlap.c
    
    Edouard.Thiel@lif.univ-mrs.fr - 16/12/2008
    
    This program creates images in several dimensions and tests with
    write/read operations if pixel addresses do not overlap.
    
    USAGE : ./test-overlap
 */

/* DO NOT EDIT !!!  Generated by npic-templa from "test-overlap.ct" */
 
#include <npic.h>



void test_2C ()
{
    Npic_image *np;
    Npic_image_2c *I;
    int y, x;
    int k;
    size_t j;
    
    printf ("---- test_2C ----\n");
    
    np = NpicCreateImage_2c (200, 300, 3, 2);
    if (np == NULL) return;
    I = NpicCastImage (np);
    
    printf ("pixtot = %ld  pixsize = %d\n", (long) I->pixtot, I->pixsize);
    
    k = 1;
    for (y = -I->ybor; y < I->ymax+I->ybor; y++)
    for (x = -I->xbor; x < I->xmax+I->xbor; x++)
        { I->pix[y][x] = k; k = 1 + (k+13) % 255; }
    
    k = 1;
    for (y = -I->ybor; y < I->ymax+I->ybor; y++)
    for (x = -I->xbor; x < I->xmax+I->xbor; x++)
        if (I->pix[y][x] != k) {
            printf ("*** ERROR: memory overlapping in %d %d \n", 
                x, y);
            NpicDestroyImage (np);
            return;
        } else k = 1 + (k+13) % 255;
    
    k = 1;
    for (j = 0; j < I->pixtot; j++)
        if (I->vec[j] != k) {
            printf ("*** ERROR: memory overlapping in %ld\n", (long) j);
            NpicDestroyImage (np);
            return;
        } else k = 1 + (k+13) % 255;

    printf ("SUCCESS: no memory overlapping neither hole\n");
    
    NpicDestroyImage (np);
}

void test_3C ()
{
    Npic_image *np;
    Npic_image_3c *I;
    int z, y, x;
    int k;
    size_t j;
    
    printf ("---- test_3C ----\n");
    
    np = NpicCreateImage_3c (100, 200, 300, 3, 4, 2);
    if (np == NULL) return;
    I = NpicCastImage (np);
    
    printf ("pixtot = %ld  pixsize = %d\n", (long) I->pixtot, I->pixsize);
    
    k = 1;
    for (z = -I->zbor; z < I->zmax+I->zbor; z++)
    for (y = -I->ybor; y < I->ymax+I->ybor; y++)
    for (x = -I->xbor; x < I->xmax+I->xbor; x++)
        { I->pix[z][y][x] = k; k = 1 + (k+13) % 255; }
    
    k = 1;
    for (z = -I->zbor; z < I->zmax+I->zbor; z++)
    for (y = -I->ybor; y < I->ymax+I->ybor; y++)
    for (x = -I->xbor; x < I->xmax+I->xbor; x++)
        if (I->pix[z][y][x] != k) {
            printf ("*** ERROR: memory overlapping in %d %d %d \n", 
                x, y, z);
            NpicDestroyImage (np);
            return;
        } else k = 1 + (k+13) % 255;
    
    k = 1;
    for (j = 0; j < I->pixtot; j++)
        if (I->vec[j] != k) {
            printf ("*** ERROR: memory overlapping in %ld\n", (long) j);
            NpicDestroyImage (np);
            return;
        } else k = 1 + (k+13) % 255;

    printf ("SUCCESS: no memory overlapping neither hole\n");
    
    NpicDestroyImage (np);
}

void test_4C ()
{
    Npic_image *np;
    Npic_image_4c *I;
    int t, z, y, x;
    int k;
    size_t j;
    
    printf ("---- test_4C ----\n");
    
    np = NpicCreateImage_4c (50, 80, 100, 150, 3, 1, 2, 4);
    if (np == NULL) return;
    I = NpicCastImage (np);
    
    printf ("pixtot = %ld  pixsize = %d\n", (long) I->pixtot, I->pixsize);
    
    k = 1;
    for (t = -I->tbor; t < I->tmax+I->tbor; t++)
    for (z = -I->zbor; z < I->zmax+I->zbor; z++)
    for (y = -I->ybor; y < I->ymax+I->ybor; y++)
    for (x = -I->xbor; x < I->xmax+I->xbor; x++)
        { I->pix[t][z][y][x] = k; k = 1 + (k+13) % 255; }
    
    k = 1;
    for (t = -I->tbor; t < I->tmax+I->tbor; t++)
    for (z = -I->zbor; z < I->zmax+I->zbor; z++)
    for (y = -I->ybor; y < I->ymax+I->ybor; y++)
    for (x = -I->xbor; x < I->xmax+I->xbor; x++)
        if (I->pix[t][z][y][x] != k) {
            printf ("*** ERROR: memory overlapping in %d %d %d %d \n", 
                x, y, z, t);
            NpicDestroyImage (np);
            return;
        } else k = 1 + (k+13) % 255;
    
    k = 1;
    for (j = 0; j < I->pixtot; j++)
        if (I->vec[j] != k) {
            printf ("*** ERROR: memory overlapping in %ld\n", (long) j);
            NpicDestroyImage (np);
            return;
        } else k = 1 + (k+13) % 255;

    printf ("SUCCESS: no memory overlapping neither hole\n");
    
    NpicDestroyImage (np);
}

void test_5C ()
{
    Npic_image *np;
    Npic_image_5c *I;
    int s, t, z, y, x;
    int k;
    size_t j;
    
    printf ("---- test_5C ----\n");
    
    np = NpicCreateImage_5c (33, 31, 35, 30, 42, 2, 3, 1, 5, 4);
    if (np == NULL) return;
    I = NpicCastImage (np);
    
    printf ("pixtot = %ld  pixsize = %d\n", (long) I->pixtot, I->pixsize);
    
    k = 1;
    for (s = -I->sbor; s < I->smax+I->sbor; s++)
    for (t = -I->tbor; t < I->tmax+I->tbor; t++)
    for (z = -I->zbor; z < I->zmax+I->zbor; z++)
    for (y = -I->ybor; y < I->ymax+I->ybor; y++)
    for (x = -I->xbor; x < I->xmax+I->xbor; x++)
        { I->pix[s][t][z][y][x] = k; k = 1 + (k+13) % 255; }
    
    k = 1;
    for (s = -I->sbor; s < I->smax+I->sbor; s++)
    for (t = -I->tbor; t < I->tmax+I->tbor; t++)
    for (z = -I->zbor; z < I->zmax+I->zbor; z++)
    for (y = -I->ybor; y < I->ymax+I->ybor; y++)
    for (x = -I->xbor; x < I->xmax+I->xbor; x++)
        if (I->pix[s][t][z][y][x] != k) {
            printf ("*** ERROR: memory overlapping in %d %d %d %d %d \n", 
                x, y, z, t, s);
            NpicDestroyImage (np);
            return;
        } else k = 1 + (k+13) % 255;
    
    k = 1;
    for (j = 0; j < I->pixtot; j++)
        if (I->vec[j] != k) {
            printf ("*** ERROR: memory overlapping in %ld\n", (long) j);
            NpicDestroyImage (np);
            return;
        } else k = 1 + (k+13) % 255;

    printf ("SUCCESS: no memory overlapping neither hole\n");
    
    NpicDestroyImage (np);
}

void test_6C ()
{
    Npic_image *np;
    Npic_image_6c *I;
    int r, s, t, z, y, x;
    int k;
    size_t j;
    
    printf ("---- test_6C ----\n");
    
    np = NpicCreateImage_6c (12, 14, 18, 15, 19, 18, 6, 4, 5, 2, 1, 3);
    if (np == NULL) return;
    I = NpicCastImage (np);
    
    printf ("pixtot = %ld  pixsize = %d\n", (long) I->pixtot, I->pixsize);
    
    k = 1;
    for (r = -I->rbor; r < I->rmax+I->rbor; r++)
    for (s = -I->sbor; s < I->smax+I->sbor; s++)
    for (t = -I->tbor; t < I->tmax+I->tbor; t++)
    for (z = -I->zbor; z < I->zmax+I->zbor; z++)
    for (y = -I->ybor; y < I->ymax+I->ybor; y++)
    for (x = -I->xbor; x < I->xmax+I->xbor; x++)
        { I->pix[r][s][t][z][y][x] = k; k = 1 + (k+13) % 255; }
    
    k = 1;
    for (r = -I->rbor; r < I->rmax+I->rbor; r++)
    for (s = -I->sbor; s < I->smax+I->sbor; s++)
    for (t = -I->tbor; t < I->tmax+I->tbor; t++)
    for (z = -I->zbor; z < I->zmax+I->zbor; z++)
    for (y = -I->ybor; y < I->ymax+I->ybor; y++)
    for (x = -I->xbor; x < I->xmax+I->xbor; x++)
        if (I->pix[r][s][t][z][y][x] != k) {
            printf ("*** ERROR: memory overlapping in %d %d %d %d %d %d \n", 
                x, y, z, t, s, r);
            NpicDestroyImage (np);
            return;
        } else k = 1 + (k+13) % 255;
    
    k = 1;
    for (j = 0; j < I->pixtot; j++)
        if (I->vec[j] != k) {
            printf ("*** ERROR: memory overlapping in %ld\n", (long) j);
            NpicDestroyImage (np);
            return;
        } else k = 1 + (k+13) % 255;

    printf ("SUCCESS: no memory overlapping neither hole\n");
    
    NpicDestroyImage (np);
}

int main ()
{
    test_2C ();
    test_3C ();
    test_4C ();
    test_5C ();
    test_6C ();
    
    return 0;
}

